DECLARE SUB SetMode (M AS SINGLE)
DECLARE SUB PlotPoint (X, Y, C AS SINGLE)
DECLARE SUB HorizLine (X, Y, L, C AS SINGLE)
DECLARE SUB VertLine (X, Y, L, C AS SINGLE)
DECLARE FUNCTION GetPoint (X, Y AS SINGLE)

TYPE RegType
  AX AS INTEGER
  BX AS INTEGER
  CX AS INTEGER
  DX AS INTEGER
  BP AS INTEGER
  SI AS INTEGER
  DI AS INTEGER
  FLAGES AS INTEGER
END TYPE

DIM InputRegs AS RegType, OutputRegs AS RegType

FUNCTION GetPoint (X, Y AS SINGLE)

  SHARED InputRegs AS RegType, OutputRegs AS RegType

  InputRegs.AX = &HD00
  InputRegs.BX = &H0
  InputRegs.CX = INT(X)
  InputRegs.DX = INT(Y)
  CALL INTERRUPT(&H10, InputRegs, OutputRegs)

  GetPoint = OutputRegs.AX AND 255

END FUNCTION

SUB HorizLine (X, Y, L, C AS SINGLE)

  SHARED InputRegs AS RegType, OutputRegs AS RegType

  FOR H = X TO X + L - 1
    InputRegs.AX = 3072 + INT(C)
    InputRegs.CX = INT(H)
    InputRegs.DX = INT(Y)
    CALL INTERRUPT(&H10, InputRegs, OutputRegs)
  NEXT H

END SUB

SUB PlotPoint (X, Y, C AS SINGLE)

  SHARED InputRegs AS RegType, OutputRegs AS RegType

  InputRegs.AX = 3072 + INT(C)
  InputRegs.CX = INT(X)
  InputRegs.DX = INT(Y)
  CALL INTERRUPT(&H10, InputRegs, OutputRegs)

END SUB

SUB SetMode (M AS SINGLE)

  SHARED InputRegs AS RegType, OutputRegs AS RegType

  InputRegs.AX = M
  CALL INTERRUPT(&H10, InputRegs, OutputRegs)

END SUB

SUB VertLine (X, Y, L, C AS SINGLE)

  SHARED InputRegs AS RegType, OutputRegs AS RegType

  FOR V = Y TO Y + L - 1
    InputRegs.AX = 3072 + INT(C)
    InputRegs.CX = INT(X)
    InputRegs.DX = INT(V)
    CALL INTERRUPT(&H10, InputRegs, OutputRegs)
  NEXT V

END SUB

